using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;

using System.IO;
using System.Configuration;

namespace sharpService
{
	public class sharpService : System.ServiceProcess.ServiceBase
	{
		/// <summary>
		/// Oggetto timer
		/// </summary>
		private System.Timers.Timer myTimer = new System.Timers.Timer();
		/// <summary>
		/// Path della directory da controllare
		/// </summary>
		private string strControlPath;
		/// <summary>
		/// Nome del file da controllare
		/// </summary>
		private string strControlFile;
		/// <summary>
		/// File di log
		/// </summary>
		private string strLogFile;
		/// <summary>
		/// Oggetto file streem per scrivere il file di log
		/// </summary>
		private System.IO.FileStream myFileStream;

		#region Ms Visual Studio Code
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public sharpService()
		{
			// This call is required by the Windows.Forms Component Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitComponent call
		}

		// The main entry point for the process
		static void Main()
		{
			System.ServiceProcess.ServiceBase[] ServicesToRun;
	
			// More than one user Service may run within the same process. To add
			// another service to this process, change the following line to
			// create a second service object. For example,
			//
			//   ServicesToRun = new System.ServiceProcess.ServiceBase[] {new Service1(), new MySecondUserService()};
			//
			ServicesToRun = new System.ServiceProcess.ServiceBase[] { new sharpService() };

			System.ServiceProcess.ServiceBase.Run(ServicesToRun);
		}

		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// sharpService
			// 
			this.ServiceName = "sharpService";

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion

		/// <summary>
		/// Metodo scatenato allo start del servizio
		/// </summary>
		protected override void OnStart(string[] args)
		{
			loadAppVariables();
			myTimer.Enabled = true;
		}
 
		/// <summary>
		/// Metodo scatenato dallo stop del servizio
		/// </summary>
		protected override void OnStop()
		{
			myTimer.Enabled = false;
		}

		/// <summary>
		/// Carica le variabili del servizio
		/// </summary>
		private void loadAppVariables(){
			//EventHandler del timer
			this.myTimer.Elapsed += new System.Timers.ElapsedEventHandler(this.myTimer_Elapsed);
			//Variabili
			strControlPath = System.Configuration.ConfigurationSettings.AppSettings["strControlPath"].ToString();
			strControlFile = System.Configuration.ConfigurationSettings.AppSettings["strEndCodeFile"].ToString();
			strLogFile = System.Configuration.ConfigurationSettings.AppSettings["strLogFile"].ToString();
		}

		/// <summary>
		/// Metodo scatenato dall'EventHandler del timer
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void myTimer_Elapsed(object sender, System.Timers.ElapsedEventArgs e){
			//scrivo nel file di log il controllo che esista il file o no
			writeTxtFile(blnCheckExists(strControlPath + strControlFile).ToString());
		}

		/// <summary>
		/// Metodo che controlla l'esistenza di un file
		/// </summary>
		/// <param name="strFilePath">Path del file</param>
		/// <returns>True se esiste, False se non esiste il file</returns>
		private bool blnCheckExists(string strFilePath){
			//oggetto fileinfo per le propriet del file da controllare
			FileInfo myCheckFile = new FileInfo(strFilePath);
			//controllo che il file esista
			if(myCheckFile.Exists)
			{
				return true;
			}
			else
			{
				return false;
			}
		}

		/// <summary>
		/// Metodo che scrive un file di testo in Append
		/// </summary>
		/// <param name="strMessage">Messaggio di errore</param>
		public void writeTxtFile(string strMessage){
			//Oggetto FileStream
			myFileStream = new FileStream(strLogFile, FileMode.Append, FileAccess.Write, System.IO.FileShare.None);
			//StreamWriter per scrivere il file di testo
			System.IO.StreamWriter myWriter = new StreamWriter(myFileStream);
			//Scrivo la linea nel file di log
			myWriter.WriteLine(System.DateTime.Now.ToString() + " - " + strMessage);
			//Chiudo gli oggetti
			myWriter.Close();
			myFileStream.Close();
		}
	}
}
